Index: /branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Analyzers/GeneticOperatorImprovementAnalyzer.cs
===================================================================
--- /branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Analyzers/GeneticOperatorImprovementAnalyzer.cs	(revision 9238)
+++ /branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Analyzers/GeneticOperatorImprovementAnalyzer.cs	(revision 9238)
@@ -0,0 +1,191 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Analysis;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.DataAnalysis.Symbolic.Regression;
+
+namespace HeuristicLab.EvolutionaryTracking {
+  /// An analyzer that looks at individual lineages in the genealogy graph
+  /// </summary>
+  [Item("GeneticOperatorImprovementAnalyzer", "An operator that records the average success of genetic operators such as crossover and mutation.")]
+  [StorableClass]
+  class GeneticOperatorImprovementAnalyzer : SingleSuccessorOperator, IAnalyzer {
+    #region Parameter names
+    private const string UpdateIntervalParameterName = "UpdateInterval";
+    private const string UpdateCounterParameterName = "UpdateCounter";
+    private const string ResultsParameterName = "Results";
+    private const string GenerationsParameterName = "Generations";
+    private const string PopulationGraphParameterName = "PopulationGraph";
+    private const string GeneticOperatorsAverageImprovementResultName = "GeneticOperatorsAverageImprovement";
+    private const string UpdateConstantsInIntermediateNodesParameterName = "UpdateConstantsInIntermediateNodes";
+    #endregion
+
+    #region Parameter properties
+    public ValueParameter<IntValue> UpdateIntervalParameter {
+      get { return (ValueParameter<IntValue>)Parameters[UpdateIntervalParameterName]; }
+    }
+    public ValueParameter<IntValue> UpdateCounterParameter {
+      get { return (ValueParameter<IntValue>)Parameters[UpdateCounterParameterName]; }
+    }
+    public ValueParameter<BoolValue> UpdateConstantsInIntermediateNodesParameter {
+      get { return (ValueParameter<BoolValue>)Parameters[UpdateConstantsInIntermediateNodesParameterName]; }
+    }
+    public LookupParameter<ResultCollection> ResultsParameter {
+      get { return (LookupParameter<ResultCollection>)Parameters[ResultsParameterName]; }
+    }
+    public LookupParameter<IntValue> GenerationsParameter {
+      get { return (LookupParameter<IntValue>)Parameters[GenerationsParameterName]; }
+    }
+    #endregion
+
+    #region Properties
+    public IntValue UpdateInterval {
+      get { return UpdateIntervalParameter.Value; }
+    }
+    public IntValue UpdateCounter {
+      get { return UpdateCounterParameter.Value; }
+    }
+    public BoolValue UpdateConstantsInIntermediateNodes {
+      get { return UpdateConstantsInIntermediateNodesParameter.Value; }
+    }
+    public IntValue Generations {
+      get { return GenerationsParameter.ActualValue; }
+    }
+    public ResultCollection Results {
+      get { return ResultsParameter.ActualValue; }
+    }
+    public bool EnabledByDefault { get { return true; } }
+    #endregion
+
+
+    [StorableConstructor]
+    private GeneticOperatorImprovementAnalyzer(bool deserializing) : base(deserializing) { }
+    private GeneticOperatorImprovementAnalyzer(GeneticOperatorImprovementAnalyzer original, Cloner cloner) : base(original, cloner) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new GeneticOperatorImprovementAnalyzer(this, cloner);
+    }
+    public GeneticOperatorImprovementAnalyzer() {
+      Parameters.Add(new ValueParameter<IntValue>(UpdateIntervalParameterName, "The interval in which the tree length analysis should be applied.", new IntValue(1)));
+      Parameters.Add(new ValueParameter<IntValue>(UpdateCounterParameterName, "The value which counts how many times the operator was called since the last update", new IntValue(0)));
+      Parameters.Add(new ValueLookupParameter<ResultCollection>(ResultsParameterName, "The results collection where the analysis values should be stored."));
+      Parameters.Add(new LookupParameter<IntValue>(GenerationsParameterName, "The number of generations so far"));
+      Parameters.Add(new ValueParameter<BoolValue>(UpdateConstantsInIntermediateNodesParameterName, "Controls whether or not the constant values of the intermediate nodes should be updated.", new BoolValue(false)));
+
+      UpdateCounterParameter.Hidden = true;
+      UpdateIntervalParameter.Hidden = true;
+    }
+
+    #region AfterDeserialization
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      if (!Parameters.ContainsKey(UpdateConstantsInIntermediateNodesParameterName))
+        Parameters.Add(new ValueParameter<BoolValue>(UpdateConstantsInIntermediateNodesParameterName, "Controls whether or not the constant values of the intermediate nodes should be updated."));
+    }
+    #endregion
+
+    #region IStatefulItem members
+    public override void InitializeState() {
+      base.InitializeState();
+      UpdateCounter.Value = 0;
+    }
+
+    public override void ClearState() {
+      base.ClearState();
+      UpdateCounter.Value = 0;
+    }
+    #endregion
+
+    public override IOperation Apply() {
+      UpdateCounter.Value++;
+      if (UpdateCounter.Value == UpdateInterval.Value) {
+        UpdateCounter.Value = 0;
+
+        if (!Results.ContainsKey(PopulationGraphParameterName)) return base.Apply();
+
+        var graph = (SymbolicExpressionTreeGenealogyGraph)Results[PopulationGraphParameterName].Value;
+
+        var nodes = graph.Nodes.Where(n => n.Rank == Generations.Value); // get the nodes in the last generation and their parents
+
+        var crossoverImprovements = new List<double>();
+        var mutationImprovements = new List<double>();
+
+        // in case we need to use it
+        var evaluator = new SymbolicRegressionConstantOptimizationEvaluator();
+        evaluator.EvaluationPartitionParameter.ActualName = "FitnessCalculationPartition";
+
+        foreach (var node in nodes.Where(n => n.InEdges != null).OrderByDescending(n => n.InEdges.Count)) {
+          double parentsQuality = node.InEdges.Select(e => e.Source).Max(v => ((SymbolicExpressionGenealogyGraphNode)v).Quality);
+          double childQuality = node.Quality;
+          double improvement = childQuality - parentsQuality;
+          if (double.IsNaN(improvement) || double.IsInfinity(improvement) || parentsQuality.IsAlmost(0.0)) improvement = 0;
+          switch (node.InEdges.Count) {
+            case 2: // crossover
+              crossoverImprovements.Add(improvement);
+              break;
+            case 1: // mutation
+              // determine if we should update the quality
+              mutationImprovements.Add(improvement);
+              break;
+          }
+        }
+
+        if (!Results.ContainsKey(GeneticOperatorsAverageImprovementResultName)) {
+          Results.Add(new Result(GeneticOperatorsAverageImprovementResultName, new DataTable()));
+        }
+        var table = Results[GeneticOperatorsAverageImprovementResultName].Value as DataTable;
+
+        double cxAvgImprovement = 0.0;
+        double cxMaxImprovement = 0.0;
+        if (crossoverImprovements.Count > 0) {
+          cxAvgImprovement = crossoverImprovements.Average();
+          cxMaxImprovement = crossoverImprovements.Max();
+        }
+        double mutAvgImprovement = 0.0;
+        double mutMaxImprovement = 0.0;
+        if (mutationImprovements.Count > 0) {
+          mutAvgImprovement = mutationImprovements.Average();
+          mutMaxImprovement = mutationImprovements.Max();
+        }
+
+
+        if (!table.Rows.ContainsKey("Average crossover improvement")) {
+          table.Rows.Add(new DataRow("Average crossover improvement") { VisualProperties = { StartIndexZero = true } });
+        }
+        table.Rows["Average crossover improvement"].Values.Add(cxAvgImprovement);
+
+        if (!table.Rows.ContainsKey("Average mutation improvement")) {
+          table.Rows.Add(new DataRow("Average mutation improvement") { VisualProperties = { StartIndexZero = true } });
+        }
+        table.Rows["Average mutation improvement"].Values.Add(mutAvgImprovement);
+
+        if (!table.Rows.ContainsKey("Best crossover improvement")) {
+          table.Rows.Add(new DataRow("Best crossover improvement") { VisualProperties = { StartIndexZero = true } });
+        }
+        table.Rows["Best crossover improvement"].Values.Add(cxMaxImprovement);
+
+        if (!table.Rows.ContainsKey("Best mutation improvement")) {
+          table.Rows.Add(new DataRow("Best mutation improvement") { VisualProperties = { StartIndexZero = true } });
+        }
+        table.Rows["Best mutation improvement"].Values.Add(mutMaxImprovement);
+
+        if (!table.Rows.ContainsKey("Average improvement")) {
+          table.Rows.Add(new DataRow("Average improvement") { VisualProperties = { StartIndexZero = true } });
+        }
+        table.Rows["Average improvement"].Values.Add((cxAvgImprovement + mutAvgImprovement) / 2);
+
+        if (!table.Rows.ContainsKey("Best improvement")) {
+          table.Rows.Add(new DataRow("Best improvement") { VisualProperties = { StartIndexZero = true } });
+        }
+        table.Rows["Best improvement"].Values.Add(Math.Max(cxMaxImprovement, mutMaxImprovement));
+      }
+      return base.Apply();
+    }
+  }
+}
Index: /branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Analyzers/SymbolicExpressionTreeFrequentPatternsAnalyzer.cs
===================================================================
--- /branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Analyzers/SymbolicExpressionTreeFrequentPatternsAnalyzer.cs	(revision 9237)
+++ /branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Analyzers/SymbolicExpressionTreeFrequentPatternsAnalyzer.cs	(revision 9238)
@@ -96,5 +96,4 @@
     }
     #endregion
-
     #region Properties
     public bool EnabledByDefault {
@@ -361,5 +360,5 @@
           // adjust weights according to the probability a child will find itself on a certain argument position
           for (int j = 0; j != possibleChildConnections.Count; ++j) {
-            var childSymbolNode = possibleChildConnections[j].Target as SymbolNode;
+            var childSymbolNode = (SymbolNode)possibleChildConnections[j].Target;
             double sumPos = childSymbolNode.Positions.Sum(x => x.Value);
             int v; childSymbolNode.Positions.TryGetValue(i, out v);
Index: /branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Analyzers/SymbolicExpressionTreePopulationDiversityAnalyzer.cs
===================================================================
--- /branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Analyzers/SymbolicExpressionTreePopulationDiversityAnalyzer.cs	(revision 9237)
+++ /branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Analyzers/SymbolicExpressionTreePopulationDiversityAnalyzer.cs	(revision 9238)
@@ -30,7 +30,8 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.DataAnalysis.Symbolic;
 
 // type definitions for ease of use
-using HeuristicLab.Problems.DataAnalysis.Symbolic;
+using CloneMapType = HeuristicLab.Core.ItemDictionary<HeuristicLab.Core.IItem, HeuristicLab.Core.IItem>;
 
 namespace HeuristicLab.EvolutionaryTracking {
@@ -46,7 +47,18 @@
     private const string UpdateCounterParameterName = "UpdateCounter";
     private const string ResultsParameterName = "Results";
-    #endregion
-
-    #region Parameter properties
+    private const string GenerationsParameterName = "Generations";
+    private const string StoreHistoryParameterName = "StoreHistory";
+    // comparer parameters
+    private const string MatchVariablesParameterName = "MatchVariableNames";
+    private const string MatchVariableWeightsParameterName = "MatchVariableWeights";
+    private const string MatchConstantValuesParameterName = "MatchConstantValues";
+    private const string SortSubtreesParameterName = "SortSubtrees";
+    // population graph
+    private const string PopulationGraphParameterName = "PopulationGraph";
+    // clone map
+    private const string GlobalCloneMapParameterName = "GlobalCloneMap";
+    #endregion
+
+    #region Parameters
     public ValueParameter<IntValue> UpdateIntervalParameter {
       get { return (ValueParameter<IntValue>)Parameters[UpdateIntervalParameterName]; }
@@ -58,10 +70,31 @@
       get { return (LookupParameter<ResultCollection>)Parameters[ResultsParameterName]; }
     }
+    public LookupParameter<IntValue> GenerationsParameter {
+      get { return (LookupParameter<IntValue>)Parameters[GenerationsParameterName]; }
+    }
+    public ValueParameter<BoolValue> StoreHistoryParameter {
+      get { return (ValueParameter<BoolValue>)Parameters[StoreHistoryParameterName]; }
+    }
     public IScopeTreeLookupParameter<ISymbolicExpressionTree> SymbolicExpressionTreeParameter {
       get { return (IScopeTreeLookupParameter<ISymbolicExpressionTree>)Parameters[SymbolicExpressionTreeParameterName]; }
     }
-    #endregion
-
-    #region Parameters
+    public ValueParameter<BoolValue> MatchVariableNamesParameter {
+      get { return (ValueParameter<BoolValue>)Parameters[MatchVariablesParameterName]; }
+    }
+    public ValueParameter<BoolValue> MatchVariableWeightsParameter {
+      get { return (ValueParameter<BoolValue>)Parameters[MatchVariableWeightsParameterName]; }
+    }
+    public ValueParameter<BoolValue> MatchConstantValuesParameter {
+      get { return (ValueParameter<BoolValue>)Parameters[MatchConstantValuesParameterName]; }
+    }
+    public ValueParameter<BoolValue> SortSubtreesParameter {
+      get { return (ValueParameter<BoolValue>)Parameters[SortSubtreesParameterName]; }
+    }
+    public LookupParameter<CloneMapType> GlobalCloneMapParameter {
+      get { return (LookupParameter<CloneMapType>)Parameters[GlobalCloneMapParameterName]; }
+    }
+    #endregion
+
+    #region Parameter properties
     public IntValue UpdateInterval {
       get { return UpdateIntervalParameter.Value; }
@@ -72,4 +105,13 @@
     public ResultCollection Results {
       get { return ResultsParameter.ActualValue; }
+    }
+    public CloneMapType GlobalCloneMap {
+      get { return GlobalCloneMapParameter.ActualValue; }
+    }
+    public IntValue Generations {
+      get { return GenerationsParameter.ActualValue; }
+    }
+    public BoolValue StoreHistory {
+      get { return StoreHistoryParameter.Value; }
     }
     #endregion
@@ -87,5 +129,11 @@
       Parameters.Add(new ValueParameter<IntValue>(UpdateCounterParameterName, "The value which counts how many times the operator was called since the last update", new IntValue(0)));
       Parameters.Add(new ValueLookupParameter<ResultCollection>(ResultsParameterName, "The results collection where the analysis values should be stored."));
-
+      Parameters.Add(new LookupParameter<IntValue>(GenerationsParameterName, "The number of generations so far."));
+      Parameters.Add(new ValueParameter<BoolValue>(MatchVariablesParameterName, "Specify if the symbolic expression tree comparer should match variable names."));
+      Parameters.Add(new ValueParameter<BoolValue>(MatchVariableWeightsParameterName, "Specify if the symbolic expression tree comparer should match variable weights."));
+      Parameters.Add(new ValueParameter<BoolValue>(MatchConstantValuesParameterName, "Specify if the symbolic expression tree comparer should match constant values."));
+      Parameters.Add(new ValueParameter<BoolValue>(SortSubtreesParameterName, "Specifies whether the subtrees of a tree should be sorted before comparison."));
+      Parameters.Add(new LookupParameter<CloneMapType>(GlobalCloneMapParameterName, "A global map keeping track of trees and their clones (made during selection)."));
+      Parameters.Add(new ValueParameter<BoolValue>(StoreHistoryParameterName, "True if the tree lengths history of the population should be stored.", new BoolValue(false)));
       UpdateCounterParameter.Hidden = true;
       UpdateIntervalParameter.Hidden = true;
@@ -106,4 +154,6 @@
     #endregion
 
+    public bool EnabledByDefault { get { return true; } }
+
     public override IOperation Apply() {
       UpdateCounter.Value++;
@@ -113,28 +163,82 @@
 
         var trees = SymbolicExpressionTreeParameter.ActualValue.ToList();
-        var canonicalSorter = new SymbolicExpressionTreeCanonicalSorter();
-        foreach (var t in trees) canonicalSorter.SortSubtrees(t);
-
-        var comparer = new SymbolicExpressionTreeNodeSimilarityComparer { MatchConstantValues = false, MatchVariableNames = false, MatchVariableWeights = false };
-
-        var distinct = 1.0 - trees.Select(x => x.Root).Distinct(comparer).Count() / (double)trees.Count;
-
-        var results = ResultsParameter.ActualValue;
-
-        if (!results.ContainsKey("PopulationDiversity"))
-          results.Add(new Result("PopulationDiversity", new DataTable("PopulationDiversity") { VisualProperties = { YAxisTitle = "Count" } }));
-        var populationDiversityTable = results["PopulationDiversity"].Value as DataTable;
-
-        if (populationDiversityTable == null) return base.Apply(); // should never happen
-
+        if (SortSubtreesParameter.Value.Value) {
+          var canonicalSorter = new SymbolicExpressionTreeCanonicalSorter();
+          foreach (var t in trees) canonicalSorter.SortSubtrees(t);
+        }
+
+        bool matchConstants = MatchConstantValuesParameter.Value.Value;
+        bool matchVarNames = MatchVariableNamesParameter.Value.Value;
+        bool matchVarWeights = MatchVariableWeightsParameter.Value.Value;
+
+        var comparer = new SymbolicExpressionTreeEqualityComparer {
+          SimilarityComparer = new SymbolicExpressionTreeNodeSimilarityComparer {
+            MatchConstantValues = matchConstants, MatchVariableNames = matchVarNames, MatchVariableWeights = matchVarWeights
+          }
+        };
+        ResultCollection results = ResultsParameter.ActualValue;
+        // population diversity
+        DataTable populationDiversityTable;
+        if (!results.ContainsKey("PopulationDiversity")) {
+          populationDiversityTable = new DataTable("PopulationDiversity") { VisualProperties = { YAxisTitle = "Diversity" } };
+          results.Add(new Result("PopulationDiversity", populationDiversityTable));
+        }
+        populationDiversityTable = (DataTable)results["PopulationDiversity"].Value;
         if (!populationDiversityTable.Rows.ContainsKey("Diversity"))
           populationDiversityTable.Rows.Add(new DataRow("Diversity") { VisualProperties = { StartIndexZero = true } });
-
+        double distinct = trees.Distinct(comparer).Count() / (double)trees.Count;
         populationDiversityTable.Rows["Diversity"].Values.Add(distinct);
+        // selection diversity
+        if (GlobalCloneMap == null) return base.Apply();
+
+        DataTable relativeSelectionCountsTable;
+        if (!results.ContainsKey("SelectedIndividuals")) {
+          relativeSelectionCountsTable = new DataTable("SelectedIndividuals") { VisualProperties = { YAxisTitle = "% Selected Individuals" } };
+          results.Add(new Result("SelectedIndividuals", relativeSelectionCountsTable));
+        }
+        relativeSelectionCountsTable = (DataTable)Results["SelectedIndividuals"].Value;
+        if (!relativeSelectionCountsTable.Rows.ContainsKey("SelectedIndividuals")) {
+          relativeSelectionCountsTable.Rows.Add(new DataRow("SelectedIndividuals") { VisualProperties = { StartIndexZero = true } });
+        }
+        double relativeSelectionCount = GlobalCloneMap.Values.Distinct().Count() / (double)trees.Count;
+        relativeSelectionCountsTable.Rows["SelectedIndividuals"].Values.Add(relativeSelectionCount);
+
+        // do a histogram of selection frequency for each individual in the population
+        DataTable selectionFrequenciesTable;
+        if (!results.ContainsKey("SelectionFrequencies")) {
+          selectionFrequenciesTable = new DataTable("Selection Frequencies") { VisualProperties = { YAxisTitle = "Selection Count" } };
+          results.Add(new Result("SelectionFrequencies", selectionFrequenciesTable));
+        }
+        selectionFrequenciesTable = (DataTable)results["SelectionFrequencies"].Value;
+        DataRow histoRow;
+        if (!selectionFrequenciesTable.Rows.ContainsKey("SelectionFrequencies")) {
+          histoRow = new DataRow("SelectionFrequencies") { VisualProperties = { StartIndexZero = true } };
+          selectionFrequenciesTable.Rows.Add(histoRow);
+        }
+        histoRow = selectionFrequenciesTable.Rows["SelectionFrequencies"];
+        var frequencies = new double[trees.Count];
+
+        var graph = (SymbolicExpressionTreeGenealogyGraph)results[PopulationGraphParameterName].Value;
+        // get graph nodes corresponding to individuals of the previous generation
+        var prevGen = graph.Nodes.Where(node => node.Rank == Generations.Value - 1).OrderByDescending(n => n.Quality).ToList();
+        for (int i = 0; i != prevGen.Count; ++i) {
+          int selFreq = GlobalCloneMap.Values.Count(t => t == prevGen[i].SymbolicExpressionTree);
+          frequencies[i] = selFreq;
+        }
+        histoRow.Values.Replace(frequencies);
+
+        bool storeHistory = StoreHistory.Value;
+        if (storeHistory) {
+          DataTableHistory selectionFrequenciesHistory;
+          if (!results.ContainsKey("SelectionFrequenciesHistory")) {
+            selectionFrequenciesHistory = new DataTableHistory();
+            results.Add(new Result("SelectionFrequenciesHistory", selectionFrequenciesHistory));
+          }
+          selectionFrequenciesHistory = (DataTableHistory)results["SelectionFrequenciesHistory"].Value;
+          selectionFrequenciesHistory.Add((DataTable)selectionFrequenciesTable.Clone());
+        }
       }
       return base.Apply();
     }
-
-    public bool EnabledByDefault { get { return true; } }
   }
 }
Index: /branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/HeuristicLab.EvolutionaryTracking-3.4.csproj
===================================================================
--- /branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/HeuristicLab.EvolutionaryTracking-3.4.csproj	(revision 9237)
+++ /branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/HeuristicLab.EvolutionaryTracking-3.4.csproj	(revision 9238)
@@ -87,11 +87,14 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="Analyzers\SymbolicExpressionTreeRelativeFragmentDepthAnalyzer.cs" />
-    <Compile Include="Analyzers\SymbolicExpressionTreeFragmentLengthsAnalyzer.cs" />
+    <Compile Include="Analyzers\SymbolicExpressionTreeShapeAnalyzer.cs" />
+    <Compile Include="Analyzers\SymbolicExpressionTreeEvolvabilityAnalyzer.cs" />
+    <Compile Include="Analyzers\Fragments\SymbolicExpressionTreeRelativeFragmentDepthAnalyzer.cs" />
+    <Compile Include="Analyzers\Fragments\SymbolicExpressionTreeFragmentLengthsAnalyzer.cs" />
     <Compile Include="Analyzers\GeneticOperatorsAverageImprovementAnalyzer.cs" />
-    <Compile Include="Analyzers\SymbolicExpressionTreeEvolvabilityAnalyzer.cs" />
     <Compile Include="Analyzers\SymbolicExpressionTreeFrequentPatternsAnalyzer.cs" />
-    <Compile Include="Analyzers\SymbolicExpressionTreeFragmentsAnalyzer.cs" />
+    <Compile Include="Analyzers\Fragments\SymbolicExpressionTreeFragmentsAnalyzer.cs" />
     <Compile Include="FPGraph.cs" />
+    <Compile Include="LineageExplorer.cs" />
+    <Compile Include="Operators\LineageAggregator.cs" />
     <Compile Include="Operators\SymbolicExpressionTreeFPBuilder.cs" />
     <Compile Include="Operators\SymbolicExpressionTreeGenealogyGraphBuilder.cs" />
Index: /branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/LineageExplorer.cs
===================================================================
--- /branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/LineageExplorer.cs	(revision 9238)
+++ /branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/LineageExplorer.cs	(revision 9238)
@@ -0,0 +1,20 @@
+﻿using System;
+using System.Collections.Generic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.EvolutionaryTracking {
+  [StorableClass]
+  public class LineageExplorer : Item {
+    public ISymbolicExpressionTreeGenealogyGraph GenealogyGraph { get; set; }
+    public IList<Tuple<ISymbolicExpressionTree, double>> Trees { get; set; }
+    public int Generations { get; set; }
+
+    private LineageExplorer(bool deserializing) : base(deserializing) { }
+    private LineageExplorer(LineageExplorer original, Cloner cloner) : base(original, cloner) { }
+    public LineageExplorer() { }
+    public override IDeepCloneable Clone(Cloner cloner) { return new LineageExplorer(this, cloner); }
+  }
+}
